package markov;

public class Collector {

    private final int prefixLength;
    private Prefix slider = getNewPrefix();


    private final Data data;

    public Collector(int prefixLength) {
        this.prefixLength = prefixLength;
        this.data = new Data(prefixLength);
    }

    public void learn(Token token) {
        data.add(slider, token);
        slider = slider.slide(token, this.prefixLength);
    }

    public void reset() {
        slider = getNewPrefix();
    }

    private Prefix getNewPrefix() {
        return new Prefix(new Token[0]);
    }

    public int getPrefixLength() {
        return prefixLength;
    }

    public Data finishAndGetData() {
        data.finish();
        return data;
    }


}
