package markov;

import java.io.Serializable;

public class Glyph implements Serializable {
    public enum Type {
        word, punctuation, control, whitespace, empty, other
    }

    private Type type;
    private String content;

    public Type getType() {
        return type;
    }

    public String getContent() {
        return content;
    }

    public Glyph(Type type, String content) {

        this.type = type;
        this.content = content;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Glyph glyph = (Glyph) o;

        return type == glyph.type && (content != null ? content.equals(glyph.content) :
                                      glyph.content == null);
    }

    @Override
    public int hashCode() {
        int result = type != null ? type.hashCode() : 0;
        result = 31 * result + (content != null ? content.hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "Glyph{" +
                "type=" + type +
                ", content='" + content + '\'' +
                '}';
    }
}
