package markov;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class Parser {



    public Map<Integer, Data> parse(Stream<Stream<Token>> input, Iterable<Integer> prefixes) {
        Collection<Collector> collectors = new ArrayList<>();
        for (Integer i : prefixes) {
            collectors.add(new Collector(i));
        }
        input.forEachOrdered(tokenStream -> {
            tokenStream.forEachOrdered(token -> {
                for (Collector c : collectors) {
                    c.learn(token);
                }
            });
            for (Collector c : collectors) {
                c.reset();
            }
        });
        return collectors.stream().collect(Collectors.toMap(Collector::getPrefixLength,
                                                            Collector::finishAndGetData));
    }
}
