package markov;

import markov.huffman.HuffmanCode;
import markov.stuff.BitConverter;
import markov.stuff.SimpleCountMap;

import java.util.Base64;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ShortenerIntHuffmanImpl extends ShortenerSimpleImpl {


    private final HuffmanCode<Integer, List<Boolean>, Boolean, SimpleCountMap.MutableInt> intCode;


    public ShortenerIntHuffmanImpl(
            Data data,
            HuffmanCode<Integer, List<Boolean>, Boolean, SimpleCountMap.MutableInt> byteCode) {
        super(data);
        this.intCode = byteCode;
    }

    String fromInts(Stream<Integer> ints) {
        List<Boolean> bl = ints.flatMap(i -> intCode.encode(i).stream()).collect(
                Collectors.toList());
        BitConverter bc = new BitConverter();
        return Base64.getUrlEncoder().encodeToString(bc.toBytes(bl));
    }

    @Override
    Stream<Integer> toInts(String hash) {
        byte[] decoded = Base64.getUrlDecoder().decode(hash);
        return intCode.decode(new BitConverter().toBits(decoded)).stream();
    }
}