package markov.huffman;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.function.BiFunction;
import java.util.function.Function;
import java.util.function.Supplier;

public class ByteHuffmanCodeBuilder<ContentType, FrequencyType extends FrequenceType<FrequencyType>> extends HuffmanCodeBuilder<ContentType, List<Boolean>, Boolean, FrequencyType> {

    private static final Supplier<List<Boolean>> rootCodeSupplier = ArrayList::new;
    private static final Supplier<Boolean> leftGlyph = () -> false;
    private static final Supplier<Boolean> rightGlyph = () -> true;
    private static final BiFunction<List<Boolean>, Boolean, List<Boolean>> combiner = (l, g) -> {
        l = new ArrayList<>(l);
        l.add(g);
        return l;
    };
    private static final Function<List<Boolean>, Iterator<Boolean>> splitter = List::iterator;


    public ByteHuffmanCodeBuilder() {
        super(rootCodeSupplier, leftGlyph, rightGlyph, combiner, splitter, (n, b) -> b ? n.getRight() : n.getLeft());
    }
}
