package markov.huffman;

class HuffmanNode<ContentType, SequenceType, FrequencyType extends FrequenceType<FrequencyType>>
        extends HuffmanTree<ContentType, SequenceType, FrequencyType> {

    private final HuffmanTree<ContentType, SequenceType, FrequencyType> left;
    private final HuffmanTree<ContentType, SequenceType, FrequencyType> right;

    HuffmanTree<ContentType, SequenceType, FrequencyType> getLeft() {
        return left;
    }

    HuffmanTree<ContentType, SequenceType, FrequencyType> getRight() {
        return right;
    }

    HuffmanNode(HuffmanTree<ContentType, SequenceType, FrequencyType> l,
                HuffmanTree<ContentType, SequenceType, FrequencyType> r) {
        super(l.getFrequency().add(r.getFrequency()));
        left = l;
        right = r;
    }
}
