package markov.huffman;

abstract class HuffmanTree<ContentType, SequenceType, FrequencyType extends FrequenceType<FrequencyType>>
        implements Comparable<HuffmanTree<ContentType, SequenceType, FrequencyType>> {
    private final FrequencyType frequency;
    private SequenceType code = null;

    HuffmanTree(FrequencyType freq) {
        frequency = freq;
    }

    FrequencyType getFrequency() {

        return frequency;
    }

    public SequenceType getCode() {
        return code;
    }

    public void setCode(SequenceType code) {
        this.code = code;
    }

    @Override
    public int compareTo(HuffmanTree<ContentType, SequenceType, FrequencyType> o) {
        return this.frequency.compareTo(o.frequency);
    }
}
