package markov.huffman;

import com.tomgibara.bits.BitVector;
import markov.stuff.CountMap;
import org.junit.jupiter.api.Test;

import java.util.BitSet;
import java.util.Map;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

class HuffmanCodeBuilderTest {
//    @Test
//    void testSimple() {
//        CountMap<String> counts = new CountMap<>();
//        counts.count("a");
//        counts.count("a");
//        counts.count("b");
//        counts.count("c");
//        counts.count("c");
//        counts.count("c");
//        counts.count("d");
//        HuffmanCodeBuilder<String, String, String, CountMap.MutableInt> decoder = new <CountMap.MutableInt>HuffmanCodeBuilder<String, String, String, CountMap.MutableInt>(counts,
//                () -> new String(),
//                p -> p.getCode() + "0",
//                p -> p.getCode() + "1",
//                mutableInt -> mutableInt.get());
//        Map<String, CountMap.MutableInt> frequencies = counts;
//        HuffmanCode<String, String> codes = decoder.generateCode();
//        assertEquals("10", codes.encode("a"));
//        assertEquals("110", codes.encode("b"));
//        assertEquals("0", codes.encode("c"));
//        assertEquals("111", codes.encode("d"));
//
//        assertEquals("a", codes.decode("10"));
//        assertEquals("b", codes.decode("110"));
//        assertEquals("c", codes.decode("0"));
//        assertEquals("d", codes.decode("111"));
//    }
//
//


    @Test
    public void testBitVectorFromTomgibara() {
        BitVector _ = new BitVector(0);
        assertEquals(0, _.size());
        assertEquals("", _.toString());

        BitVector _0 = _.resizedCopy(1, true);
        _0.setBit(0, false);
        assertEquals(0, _.size());
        assertEquals("", _.toString());
        assertEquals(1, _0.size());
        assertEquals("0", _0.toString());

        BitVector _1 = _.resizedCopy(1, true);
        _1.setBit(0, true);
        assertEquals(0, _.size());
        assertEquals("", _.toString());
        assertEquals(1, _0.size());
        assertEquals("0", _0.toString());
        assertEquals(1, _1.size());
        assertEquals("1", _1.toString());
    }
}